#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\decframe.h>
#include <owl\dialog.h>
#include <owl\radiobut.h>
#include <owl\gdiobjec.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\messageb.h>

#include "cur.rc"

//  .
struct
{
  BOOL buttons [14];
} transBuf;

// .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public   TDecoratedFrame
{
  public:
	 TWndw (TWindow *parent, const char far *title, TWindow *client, BOOL tr);
  protected:
	void mycurs(char *cursor);
	 void CmCursor();
	 void ChangeCursor();
	 void CmAbout();   //about
	 void CmMy1(){mycurs("IDC_MYCUR1");};
	 void CmMy2(){mycurs("IDC_MYCUR2");};



	 DECLARE_RESPONSE_TABLE (TWndw);

};

DEFINE_RESPONSE_TABLE1 (TWndw, TDecoratedFrame)
	EV_COMMAND (CM_CURSOR, CmCursor),
	EV_COMMAND(CM_ABOUT, CmAbout),
	EV_COMMAND(CM_MY1, CmMy1),
	EV_COMMAND(CM_MY2, CmMy2),
END_RESPONSE_TABLE;

//    Select Cursor.
class TDlg : public TDialog
{
  public:
	 TDlg(TWindow *parent, TResId resId);
};

// TWndw::TWndw()
// R  .
TWndw::TWndw(TWindow *parent, const char far *title,TWindow *client, BOOL tr):TDecoratedFrame(parent, title, client, tr)

{
  //     .
  Attr.W=GetSystemMetrics(SM_CXSCREEN)/2;
  Attr.H=GetSystemMetrics(SM_CYSCREEN)/2;
  Attr.X=GetSystemMetrics(SM_CXSCREEN)/2-Attr.W/2;
  Attr.Y=GetSystemMetrics(SM_CYSCREEN)/2-Attr.H/2;
  //++++
  TButtonGadget *but;     //
  TSeparatorGadget *sep;  //
  AssignMenu(MENU_1);
  TControlBar *cntrlbar = new TControlBar(this, TControlBar::Vertical);

  sep=new TSeparatorGadget(50);     //separator
  cntrlbar->Insert(*sep);
  but=new TButtonGadget(BMP_CURTYPE, CM_CURSOR);     //new
  cntrlbar->Insert(*but);
  sep=new TSeparatorGadget(10);
  cntrlbar->Insert(*sep);
  but=new TButtonGadget(BMP_ABOUT, CM_ABOUT);        //open
  cntrlbar->Insert(*but);
  sep=new TSeparatorGadget(10);
  cntrlbar->Insert(*sep);
  but=new TButtonGadget(BMP_EXIT, CM_EXIT);            //exit
  cntrlbar->Insert(*but);
  Insert(*cntrlbar, TDecoratedFrame::Left);
  cntrlbar->SetHintMode(TGadgetWindow::EnterHints);    //hint's
		TControlBar *cntrlbar2 = new TControlBar(this, TControlBar::Vertical);
		 sep=new TSeparatorGadget(50);     //separator
			cntrlbar2->Insert(*sep);
			 but=new TButtonGadget(BITMAP_1, CM_MY1);     //new
			 cntrlbar2->Insert(*but);
			 sep=new TSeparatorGadget(10);
			 cntrlbar2->Insert(*sep);
			 but=new TButtonGadget(BITMAP_1, CM_MY2);        //open
			 cntrlbar2->Insert(*but);
			 Insert(*cntrlbar2, TDecoratedFrame::Right);
  TMessageBar *msgbar = new TMessageBar(this);
  msgbar->SetText(":");
  Insert(*msgbar, TDecoratedFrame::Bottom);//status barr
  //====
  //    .
  AssignMenu(MENU_1);
  //   .
  memset (&transBuf,0,sizeof(transBuf));
  transBuf.buttons[0] = TRUE;
}

// TWndw::CmCursor()
//      CM_CURSOR,
//  ,  
//   Select Cursor   Cursor.
void TWndw::CmCursor()
{
  //    Select Cursor.
  TDialog *dialog = new TDlg (this, CURSORDLG);
  //  .
  int result = dialog->Execute();
  //      ...
  if (result == IDOK)
	 //    .
	 ChangeCursor();
}

void TWndw::mycurs(char *cursor)
{
 HINSTANCE  instance;
	HCURSOR  hCursor;
 instance = *GetApplication() ;
//    .
  hCursor = LoadCursor (instance, cursor);
  //     
  //    .
  SetClassWord (GCW_HCURSOR, (WORD) hCursor);
}

void TWndw::CmAbout()
{
  MessageBox(" ", " ", MB_OK);
}


// TWndw::ChangeCutsor()
//      
//    -  
//   SelectCursor,   
//   .
void TWndw::ChangeCursor()
{
  int selection;
  const char *cursor;
  HINSTANCE  instance;
  HCURSOR  hCursor;
  //   -.
  for (int x = 0; x < 14; ++x)
	 if (transBuf.buttons[x]) selection = x;
  //   ,  .
  switch (selection)
  {
	 case  0 :  cursor = IDC_ARROW;break;
	 case  1 :  cursor = IDC_CROSS;break;
	 case  2 :  cursor = IDC_IBEAM;break;
	 case  3 :  cursor = IDC_ICON;break;
	 case  4 :  cursor = IDC_SIZE;break;
	 case  5 :  cursor = IDC_SIZENESW;break;
	 case  6 :  cursor = IDC_SIZENS;break;
	 case  7 :  cursor = IDC_SIZENWSE; break;
	 case  8 :  cursor = IDC_SIZEWE; break;
	 case  9 :  cursor = IDC_UPARROW; break;
	 case 10 :  cursor = IDC_WAIT; break;
	 case 11 :  cursor = "IDC_TARGET"; break;
	 case 12 :  cursor = "IDC_MYCUR1"; break;
	 case 13 :  cursor = "IDC_MYCUR2"; break;
  }
  //      ...
  if (selection >= 11)
	 //      .
	 instance = *GetApplication() ;
  else
	 //   instance  NULL, 
	 //     Windows.
	 instance = NULL;
  //    .
  hCursor = LoadCursor (instance, cursor);
  //     
  //    .
  SetClassWord (GCW_HCURSOR, (WORD) hCursor);
}
//**************************************
//   TDlg.
//**************************************
// TDlg::TDlg()
//     SelectCursor.
TDlg::TDlg(TWindow *parent, TResId resId): TDialog (parent, resId)
{
  //    OWL  
  //    , 
  //      .
  new TRadioButton(this, ID_ARROWBUT, 0);
  new TRadioButton(this, ID_CROSSBUT, 0);
  new TRadioButton(this, ID_IBEAMBUT, 0);
  new TRadioButton(this, ID_ICONBUT, 0);
  new TRadioButton(this, ID_SIZEBUT, 0);
  new TRadioButton(this, ID_NESWBUT, 0);
  new TRadioButton(this, ID_NSBUT, 0);
  new TRadioButton(this, ID_NWSEBUT, 0);
  new TRadioButton(this, ID_WEBUT, 0);
  new TRadioButton(this, ID_UPBUT, 0);
  new TRadioButton(this, ID_WAITBUT, 0) ;
  new TRadioButton(this, ID_TARGETBUT, 0);
  new TRadioButton(this, ID_MY1BUT, 0);
  new TRadioButton(this, ID_MY2BUT, 0);

  //    .
  TransferBuffer = &transBuf;
}

void TApp::InitMainWindow()
{
  TWindow *client = new TWindow(0,0,0);
  TDecoratedFrame *wndw = new TWndw(0, "Main Form", client, TRUE);
  SetMainWindow(wndw);
  EnableBWCC();
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
